#include <math.h>
#define PI 3.1415926

u8 dval;
u8 powpos[10];

void set_angle(u8 angle) //180 - full power
{
 if(angle>180) angle=180;
 
 dval = 0xff-(u16)angle*0xff/180; 
}

void set_airflow(u8 val) //9 - max airflow
{
 u16 tmp = TIM1->ARRH<<8;
     tmp|= TIM1->ARRL;
     
 if(val>9)val=9;
// else if(val<2)val=2;
 
 if(val==9)
 {
  TIM1->BKR&=~TIM1_BKR_MOE;
 }
 else
 {
  tmp = tmp*val/9;
  TIM1->CCR1H = TIM1->CCR2H = tmp>>8;
  TIM1->CCR1L = TIM1->CCR2L = (u8)tmp;
  TIM1->BKR = TIM1_BKR_MOE;  
 }
}

void calc_pw()
{
 for(u8 i=0;i<5;i++) powpos[i] = (u8)((float)90*sin((float)i*18*PI/2/90));  

 for(u8 i=5;i<10;i++)
 {
  static u8 k=0;
  k++;  
  powpos[i] = 180 - powpos[5-k];
 }
}

void set_pow (u8 pow) //9 - max power
{
 if(pow>9)pow=9; 
 set_angle(powpos[pow]); 
}