
#define A   PORTD.4
#define B   PORTD.3
#define C   PORTD.2
#define D   PORTD.1
#define E   PORTD.0
#define F   PORTC.4
#define G   PORTC.3
#define DP  PORTC.2

#define N0      PORTD.7
#define N0_ddr  DDRD.7
#define N0_idr  PIND.7
#define N1      PORTD.6
#define N1_ddr  DDRD.6
#define N2      PORTD.5 
#define N2_ddr  DDRD.5
//#define N3      zzz
//#define N3_ddr  zzz

#define DNUM  3

bit ss_pol;   //0==CC
u8 dbuf[DNUM]  = {'_','_','_'};
bool dpp[DNUM] = {0,0,0};

void display_data ()
{
 static u8 sp;
 static u8 dtmp[DNUM];
 static bool dptmp[DNUM]; 
 static u8 tmp[DNUM]; 
 u8 i;
 
 for(i=0;i<DNUM;i++)
 {
  //if(dtmp[i]!=dbuf[i] || dptmp[i]!=dpp[i]) 
  {
   dtmp[i]  = dbuf[i];
   dptmp[i] = dpp[i];
   
   switch (dbuf[i])
   {
    case 0: tmp[i] = 0b0000001; break;
    case 1: tmp[i] = 0b1001111; break;
    case 2: tmp[i] = 0b0010010; break;
    case 3: tmp[i] = 0b0000110; break;
    case 4: tmp[i] = 0b1001100; break;
    case 'S':
    case 5: tmp[i] = 0b0100100; break;
    case 6: tmp[i] = 0b0100000; break;
    case 7: tmp[i] = 0b0001111; break;
    case 8: tmp[i] = 0b0000000; break;
    case 9: tmp[i] = 0b0000100; break;

    case 10: tmp[i] = 0b0111111; break;
    case 11: tmp[i] = 0b1011111; break;
    case 12: tmp[i] = 0b1101111; break;
    case 13: tmp[i] = 0b1110111; break;
    case 14: tmp[i] = 0b1111011; break;
    case 15: tmp[i] = 0b1111101; break;
    case 16: tmp[i] = 0b1111110; break;

    case ' ': tmp[i] = 0b1111111; break;
    case 'v':
    case 'u': tmp[i] = 0b1100011; break;
    case 'c': tmp[i] = 0b1110010; break;
    case 'b': tmp[i] = 0b1100000; break;
    case 't': tmp[i] = 0b1110000; break;
    case 'l': tmp[i] = 0b1110011; break;
    case 'o': tmp[i] = 0b1100010; break;
    case 'A': tmp[i] = 0b0001000; break;
    case 'H': tmp[i] = 0b1001000; break;
    case 'C': tmp[i] = 0b0110001; break;
    case 'P': tmp[i] = 0b0011000; break;
    case 'E': tmp[i] = 0b0110000; break;
    case 'U': tmp[i] = 0b1000001; break;
    case 'f':
    case 'F': tmp[i] = 0b0111000; break;
    case 'L': tmp[i] = 0b1110001; break;
    case 'r': tmp[i] = 0b1111010; break;
    case '_': tmp[i] = 0b1110111; break;
    case 'd': tmp[i] = 0b1000010; break;
    case 'n': tmp[i] = 0b1101010; break;
    case 'G': tmp[i] = 0b0100001; break;
    case 'N': tmp[i] = 0b0001001; break;
    case 'O': tmp[i] = 0b0000001; break;
    case 'i': tmp[i] = 0b1111011; break;
    case 'I': tmp[i] = 0b1111001; break;
    case 'J': tmp[i] = 0b1000111; break;
    case 'h': tmp[i] = 0b1101000; break;
    default:  tmp[i] = 0b1111110; break; //-
   }
   tmp[i]|=~dpp[i]<<7;
   
   if(ss_pol)tmp[i]=~tmp[i];
  } 
 }

 if(sp)sp--;
 else sp=7;
 
 i=1<<sp;
       
 A=B=C=D=E=F=G=DP=ss_pol; 
 
#if   DNUM==1 
 N0 = !!(tmp[0]&i);
#elif DNUM==2 
 N0 = !!(tmp[0]&i);
 N1 = !!(tmp[1]&i);
#elif DNUM==3 
 N0 = !!(tmp[0]&i);
 N1 = !!(tmp[1]&i);
 N2 = !!(tmp[2]&i); 
#elif DNUM==4 
 N0 = !!(tmp[0]&i);
 N1 = !!(tmp[1]&i);
 N2 = !!(tmp[2]&i);                      
 N3 = !!(tmp[3]&i);  
#endif 
 
 i = !ss_pol;
 
 switch(sp)
 {  
  case 7: DP=i;
  break;   
  case 6: A=i;
  break;  
  case 5: B=i;
  break;   
  case 4: C=i;
  break;  
  case 3: D=i;
  break;  
  case 2: E=i;
  break;  
  case 1: F=i;
  break;  
  case 0: G=i;
  break;   
 }     
}

bool detect_7seg_polarity(void)
{
 u8 i;
 u8 n=0;

 A=B=C=D=E=F=G=DP=0;
#if   DNUM==1 
 N0=          N0_ddr=0;
#elif DNUM==2 
 N1=N0=       N1_ddr=N0_ddr=0;
#elif DNUM==3 
 N2=N1=N0=    N2_ddr=N1_ddr=N0_ddr=0;
#elif DNUM==4 
 N3=N2=N1=N0= N3_ddr=N2_ddr=N1_ddr=N0_ddr=0; 
#endif  

 for(i=0xff;i;i--)
 {
  if(!N0_idr)n++;
  else if(n)n--;
 }
  
#if   DNUM==1 
 N0_ddr=1;
#elif DNUM==2 
 N1_ddr=N0_ddr=1;
#elif DNUM==3 
 N2_ddr=N1_ddr=N0_ddr=1;
#elif DNUM==4 
 N3_ddr=N2_ddr=N1_ddr=N0_ddr=1; 
#endif   
 
 if(n>0xff/2)return 1;
 return 0;
}

void convert_data (s16 d)
{
 u8 k;    
 static bit trg=0;
 static u16 top;
 
 if(!trg)
 {
  trg=1;
  top=1;
  for(k=0;k<DNUM;k++)top*=10;
  top--;
 }
 
 if(d<0)
 {
  if(d<-(top/10))for(k=0;k<DNUM;k++)dbuf[k]='L';
  else
  {  
   dbuf[DNUM-1]='-';
   d=-d;
   for (k=0;k<DNUM-1;k++)
   {
    dbuf[k]=d%10;
    if(k==DNUM-2)if(!dbuf[k])dbuf[k]=' ';  
    d/=10;
   }  
  }
 }
 else
 {
 for (k=0;k<DNUM;k++)
  {   
   if(d>top)for(k=0;k<DNUM;k++)dbuf[k]='H';
   else
   {
    dbuf[k]=d%10;
    if(k==DNUM-1)
    {
     if(!dbuf[k])
     {
      dbuf[k]=' ';  
      if(!dbuf[k-1])dbuf[k-1]=' ';
     }    
    }
    d/=10;
   }
  } 
 }
}

