#define RFB         10000UL          //Ohms
#define RTG         100              //Ohms
#define K_PAIR      407               //uV
#define ADCMAX      2560UL            //mV
#define K_AMPLIFIER (100+RFB*100/RTG) //LM358 amplification 101*100
#define MAXTC       (ADCMAX*1000*100/K_PAIR*1000/K_AMPLIFIER)//622.76*100
#define CPADC       (MAXTC*100/0x3ff)  //     0.6087*10000

u16 adc_retval_1, adc_retval_0;
bit adc_ready;    


bool read_adc(u16 *result_0, u16 *result_1)
{
 static bit trg;
 if(!trg)
 {
  trg=1;
  adc_ready = 0;
 }
  
 if(adc_ready)
 {
  *result_1 = adc_retval_1*ADCMAX>>10; 
  *result_0 = adc_retval_0*ADCMAX>>10;  
  trg=0;
  return 1;
 }  
 return 0; 
}

bool get_T(s16 *TC)
{
 u16 v_tcp, v_d, t_tcp; 
 s16 t_d;
 
 if(read_adc(&v_tcp, &v_d)==1)
 {
  t_d = ((s32)ee_T20_d*10-((s32)v_d-ee_V20_d)*1000/21)/10;
  
  t_tcp = ((u32)v_tcp*CPADC/ADCMAX<<10)/100;  
  if(t_tcp>ee_T_offset)t_tcp -= ee_T_offset;
  else t_tcp=0;
  
  *TC = (s16)(((s32)t_tcp + t_d)/100);   

  return 1; 
 }
 return 0;
}


