#define size 30

eeprom u8 ee_bg[5];
eeprom u8 ee_airflow[size];
eeprom u8 ee_t[size];
eeprom u8 ee_onoff[size];
eeprom u16 ee_T20_d, ee_V20_d;
eeprom u16 ee_T_offset;
eeprom u8 ee_init;

void write_ee(u8 val, eeprom u8 storage[], u8 msize)
{
 u8 i;
 for(i=0;i<msize;i++)
 {
  if(storage[i]!=0xff)
  {
   if(storage[i]!=val)
   {
    storage[i]=0xff;
    if(i<msize-1)storage[i+1] = val;
    else         storage[0]   = val;
   }
   return;
  }
 }

 storage[0] = val; 
}

u8 read_ee(eeprom u8 storage[], u8 msize)
{
 u8 i;
 for(i=0;i<msize;i++)
 {
  if(storage[i]!=0xff)return storage[i];
 }
 return 0xff;   
}

#define initval 0xb1
void ee_set()
{
 if(ee_init!=initval)
 {    
  ee_T20_d    = 20*100;
  ee_V20_d    = 600;
  ee_T_offset = 30*100;

  ee_bg[0]=1;
  write_ee(100, ee_airflow, sizeof(ee_airflow));
  write_ee(30, ee_t, sizeof(ee_t));
  write_ee(1, ee_onoff, sizeof(ee_onoff));
  
  ee_init = initval;
 }
}