 #define lp  5
 #define lh  15
 #define lr  3 
      
 #define noc 3
 #define key0   PINB.3
 #define key1   PINB.4
 #define key2   PINB.5  
 
 #define AF 0
 #define DN 1
 #define UP 2

 u8 kb_timer;    
 enum {rls, prs, hold} btn[noc];

 void scan_keys()
 {
  static u8 count[noc*3];
  u8 key_st[noc];  
  u8 i;  

  key_st[0] = key0;
  key_st[1] = key1;  
  key_st[2] = key2;  

  for(i=0;i<noc;i++) 
  { 
   if (!key_st[i])
   {
    if (count[i*3]>lp) 
    {
     count[i*3]=0;
    
     if(btn[i]==rls)btn[i]=prs;
     if(count[i*3+1]>lh) {btn[i]=hold; count[i*3+1]=0;}
     else count[i*3+1]++;
    }
    else count[i*3]++;  
   
    count[i*3+2]=lr;
   } 
   else
   {
    if(count[i*3+2])count[i*3+2]--;
    else {count[i*3]=count[i*3+1]=0;btn[i]=rls;} 
   }  
  }    
 }   

 void kb_input(u16 *value, const u16 min_value, const u16 max_value, const u8 step, const u16 hstep, const u8 rfq)
 {
  static bit btp0,btp1;
  static bit btn_trg1;  
   
  if(btn[DN]==prs&&btn[UP]==prs&&!btn_trg1){btp1=btp0=0;}

  if(btn[DN]==prs&&btn[UP]==rls&&!btn_trg1)
  {
   btn_trg1=1;
   btp0 = 1;
  }
  else if(btn[DN]==rls&&btn[UP]==prs&&!btn_trg1)
  {
   btn_trg1=1;
   btp1 = 1;
  }
  else if(btn[DN]==hold&&btn[UP]==rls)
  {
   btp1=btp0=0;
   if(!kb_timer)
   {
    kb_timer=rfq;
    if(*value>min_value+hstep)*value-=hstep;
    else *value=min_value;
   }
  }
  else if(btn[DN]==rls&&btn[UP]==hold)
  {
   btp1=btp0=0;
   if(!kb_timer)
   {
    kb_timer=rfq;
    if(*value<max_value-hstep)*value+=hstep;
    else *value=max_value;
   }  
  }

  if(btn[DN]==rls&&btn[UP]==rls)btn_trg1=0;
  if(!btn_trg1)
  {
   if(btp0)
   {
    btp1=btp0=0;
    if(*value>min_value+step)*value-=step;
    else *value=min_value;
   }
   else if(btp1)
   {
    btp1=btp0=0; 
    if(*value<max_value-step)*value+=step; 
    else *value=max_value; 
   } 
  }   
 }
 